#ifndef WIDGETS_TEXT_H
#define WIDGETS_TEXT_H

#include "widget.h"
#include <string>

namespace widgets {
    
    class Text : public Widget {
    public:
        
        virtual ~Text() {}
        
        // Attributes can contain the following keys:
        // "text"
        
    protected:
        
        // Draws the text when it needs to be drawn.  xstart and ystart are added to the widget's
        // x / y position to deduce the drawing position.
        virtual void draw(int xstart, int ystart, const Tint &tint);
    };
}

#endif
