#include "widget.h"
#include <algorithm>
using namespace std;

#define eventParm(name, parmType) \
Widget::Action Widget::send##name (parmType parm) \
{ \
    Action ret = on##name (parm); \
    for(list<EventRecieverAsync*>::iterator itr = eventRecievers.begin(); itr != eventRecievers.end(); ++itr) { \
        (*itr)->on##name (parm); \
    } \
    return ret; \
}

#define event(name) \
Widget::Action Widget::send##name () \
{ \
    Action ret = on##name (); \
    for(list<EventRecieverAsync*>::iterator itr = eventRecievers.begin(); itr != eventRecievers.end(); ++itr) { \
        (*itr)->on##name (); \
    } \
    return ret; \
}

eventParm(Key, int);
event(Focus);
event(Unfocus);
event(Hover);
event(Leave);
event(Click);
event(Release);
event(Idle);

list<EventRecieverAsync*> operator +(EventRecieverAsync &eventReciever1, EventRecieverAsync &eventReciever2)
{
    list<EventRecieverAsync*> ret(1, &eventReciever1);
    
    ret.push_back(&eventReciever2);
    
    return ret;
}

list<EventRecieverAsync*> operator +(const list<EventRecieverAsync*> &eventRecievers, EventRecieverAsync &eventReciever)
{
    list<EventRecieverAsync*> ret(eventRecievers);
    
    ret.push_back(&eventReciever);
    
    return ret;
}

list<EventRecieverAsync*> &operator +=(list<EventRecieverAsync*> &eventRecievers1, const list<EventRecieverAsync*> &eventRecievers2)
{
    list<EventRecieverAsync*>::iterator start = eventRecievers1.begin();
    
    for(unsigned int i = 1; i < eventRecievers1.size(); i++)
        ++start;
    
    eventRecievers1.resize(eventRecievers1.size() + eventRecievers2.size());
    
    copy(eventRecievers2.begin(), eventRecievers2.end(), ++start);
    
    return eventRecievers1;
}

list<EventRecieverAsync*> &operator +=(list<EventRecieverAsync*> &eventRecievers, EventRecieverAsync &eventReciever)
{
    eventRecievers.push_back(&eventReciever);
    
    return eventRecievers;
}
