#ifndef BUILDINGS_H
#define BUILDINGS_H

#include <string>
#include <map>

class Buildings {
public:
    
    // Loads the building database from the filename suggested by the filename
    // parameter.
    void load(const std::string &filename);
    
    // Properties of an building
    struct Building {
        int cost;
        std::string name, descr;
        
        Building() : cost(0) {}
    };
    
    // Building ID as the Key, building properties as the value
    std::map<unsigned int, Building> buildings;
};

#endif
