#ifndef CITY_H
#define CITY_H

#include <map>
#include <string>
#include "terminal.h"

class City {
public:
    City(const std::string& name = "");
    
    ~City();
    
    /// Name of the city
    std::string name;
    /// List of terminals existing inside this city
    std::map<int, unsigned int> terminals;
    /// Position of the city
    int x, y;
};

#endif
