#ifndef TRAIN_H
#define TRAIN_H

class Train {
public:
    
    // the type of this train car (lookupable in itemDb as well as traindb).
    unsigned int type;
    
    // The track this train car is on
    unsigned int track;
    
    // the player that owns this train car
    unsigned int player;
    
    // The unique ID for the parent train car (think linked list)
    unsigned int parentCar;
    
    // The unique ID for the child train car (think linked list)
    unsigned int childCar;
};

#endif
