#ifndef TRAINS_H
#define TRAINS_H

#include <string>
#include <map>

// Maintins properties for all train items.  The item ids are the same as they
// are in the item database.
class Trains {
public:
    
    // Loads the train database from the filename suggested by the filename
    // parameter.
    void load(const std::string &filename);
    
    // Properties of an train
    struct Train {
        int passengerLimit;
        
        Train() : passengerLimit(0) {}
    };
    
    // Item ID as the Key, Train properties as the value
    std::map<unsigned int, Train> trains;
};

#endif
