#include "eventreciever.h"
using namespace std;

EventRecieverAsync::EventRecieverAsync()
    :  keyEvent(0), keyEventParm(0), focusEvent(0), unfocusEvent(0), hoverEvent(0),
       leaveEvent(0), clickEvent(0), releaseEvent(0)
{
    
}

void EventRecieverAsync::onKey(int key)
{
    keyEvent = true;
    keyEventParm = key;
}

void EventRecieverAsync::onFocus()
{
    focusEvent = true;
}

void EventRecieverAsync::onUnfocus()
{
    unfocusEvent = true;
}

void EventRecieverAsync::onHover()
{
    hoverEvent = true;
}

void EventRecieverAsync::onLeave()
{
    leaveEvent = true;
}

void EventRecieverAsync::onClick()
{
    clickEvent = true;
}

void EventRecieverAsync::onRelease()
{
    releaseEvent = true;
}

void EventRecieverAsync::onIdle()
{
    idleEvent = true;
}

bool EventRecieverAsync::onKeyAsync(int &key)
{
    if(keyEvent) {
        
        keyEvent = false;
        key = keyEventParm;
        return true;
    }
    
    return false;
}

bool EventRecieverAsync::onFocusAsync()
{
    if(focusEvent) {
        
        focusEvent = false;
        return true;
    }
    
    return false;
}

bool EventRecieverAsync::onUnfocusAsync()
{
    if(unfocusEvent) {
        
        unfocusEvent = false;
        return true;
    }
    
    return false;
}

bool EventRecieverAsync::onHoverAsync()
{
    if(hoverEvent) {
        
        hoverEvent = false;
        return true;
    }
    
    return false;
}

bool EventRecieverAsync::onLeaveAsync()
{
    if(leaveEvent) {
        
        leaveEvent = false;
        return true;
    }
    
    return false;
}

bool EventRecieverAsync::onClickAsync()
{
    if(clickEvent) {
        
        clickEvent = false;
        return true;
    }
    
    return false;
}

bool EventRecieverAsync::onReleaseAsync()
{
    if(releaseEvent) {
        
        releaseEvent = false;
        return true;
    }
    
    return false;
}

bool EventRecieverAsync::onIdleAsync()
{
    if(idleEvent) {
        
        idleEvent = false;
        return true;
    }
    
    return false;
}
