#include "world.h"
#include "track.h"
using namespace std;

Track::Track()
    : directions(3)
{
    
}

Track::~Track()
{
    
}

void Track::find_adjacent(vector<unsigned int>& adjacent)
{
    directions = 0;
    for(map<unsigned int, Track>::iterator i = world.tracks.begin(); i != world.tracks.end(); i++)
    {
        if(&i->second == this)
            continue;
        int ox = i->second.x, oy = i->second.y;
        bool add = false;
        if(ox == x && oy == y - 1)
        {
            add = true;
            directions |= 0x01;
            i->second.directions |= 0x02;
        }
        if(ox == x && oy == y + 1)
        {
            add = true;
            directions |= 0x02;
            i->second.directions |= 0x01;
        }
        if(ox == x - 1 && oy == y)
        {
            add = true;
            directions |= 0x04;
            i->second.directions |= 0x08;
        }
        if(ox == x + 1 && oy == y)
        {
            add = true;
            directions |= 0x08;
            i->second.directions |= 0x04;
        }
        if(add)
            adjacent.push_back(i->first);
    }
}
