#include "widgets_text.h"
#include "print.h"
using namespace std;
using namespace widgets;

void Text::draw(int xstart, int ystart, const Tint &tint)
{
    int w = Print::getFontRenderer().stringWidth(attributes["text"]);
    
    if(attributes["align"] == "center")
        Print(xstart - w / 2, ystart, tint) << attributes["text"];
    else if(attributes["align"] == "right")
        Print(xstart - w, ystart, tint) << attributes["text"];
    else
        Print(xstart, ystart, tint) << attributes["text"];
}
